#include <stdio.h>

#include "location.h"
#include "alloc.h"

location_t *
locaton_new(double n, double w)
{
	location_t *l;

	l = malloc(sizeof(*l));
	l->n = n;
	l->w = w;

	return l;
}

void
location_free(location_t *l)
{
	free(l);
}

void
location_to_string(location_t *l, char *buf)
{
	sprintf(buf, "[%2.6lf %2.6lf]", l->n, l->w);
}

void
location_print(location_t *l)
{
	char buf[128];

	location_to_string(l, buf);
	printf("%s\n", buf);
}
