#include <stdio.h>
#include <err.h>
#include <pthread.h>
#include <assert.h>
#include <stdlib.h>

#include "server.h"
#include "queue.h"
#include "protocol.h"
#include "poll.h"
#include "user.h"

int
inc_print(void *_a)
{
	int *a = _a;

	printf("a is now: %d\n", *a);
	(*a)++;

	return 0;
}

int
die_flaming_death(void *a)
{
	(void) a;

	errx(1, "Flaaaaames!");

	return 0;
}

queue_t *q;
int process_queue = 1;

void *
queue_processor_worker(void *a)
{
	queue_processer(q, a);

	return NULL;
}

int
main(int argc, char **argv)
{
	int a, i;
	pthread_t td1, td2, td_listener;
#if 0
	char *s = "update user \"foo\" \"abc\" [N37 23.516 W122 02.625]";
#endif
	struct server_handler_args server_handler_args;

#if 0
	protocol(s);
	protocol("fetch \"foo\"");
	s = "update user \"foo\" \"abc\" [N37 53.516 W122 02.625]";
	protocol(s);
	protocol("fetch \"foo\"");
	return 0;
#endif

	if (argc < 3)
		errx(1, "Please specify a port to bind to and server id");

	poller_init();
	user_init();
	server_read_list("config/server.list");
	server_id = atoi(argv[2]);
	if (server_id < 1)
		errx(1, "Server id must be 1 or greater");
	if (server_listen(argv[1], &server_handler_args) == 0)
		errx(1, "Unable to listen on port %s", argv[1]);

	q = queue_new();
	pthread_create(&td1, NULL, queue_processor_worker, &process_queue);
	server_handler_args.queue = q;
	pthread_create(&td_listener, NULL, server_handler, &server_handler_args);
	pthread_join(td_listener, NULL);

	errx(1, "Foo: ");


	pthread_create(&td2, NULL, queue_processor_worker, &process_queue);

	a = 0;

	printf("Binding to port: %s\n", argv[1]);


	for (i = 0; i < atoi(argv[1]); i++) {
		queue_add(q, &inc_print, &a);
	}

	queue_add(q, &die_flaming_death, NULL);
	sleep(3);
	process_queue = 0;

	return 0;
}
